/************************************************************************
 *																		*
 *	Copyright (c) 2001 by			David A. Wallace					*
 *									154 Dunstable Rd.					*
 *									N. Chelmsford, MA					*
 *											01863-1202					*
 *																		*
 ************************************************************************/


#include <afx.h>
#include "lasterrortext.h"



CString	GetLastErrorText(DWORD dwErrCode)
{
	char *	pMessageText = NULL;
	DWORD	dwInternalErrorCode;
	int		nIndex;
	CString	strMessage;

//	We'll let the call allocate the buffer (it uses LocalAlloc).

	if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | 
						FORMAT_MESSAGE_ALLOCATE_BUFFER,
						NULL,
						dwErrCode,
#if 0
//	What I want to do...
						GetSystemDefaultLangID(),
#else
//	What I have to do...
						MAKELANGID(LANG_NEUTRAL, SUBLANG_SYS_DEFAULT),
#endif
						(LPTSTR) &pMessageText,
						32,
						NULL) == 0)
	{
		dwInternalErrorCode = GetLastError();

#if 1	// for debug purposes -- initially all errors are fatal.

		char szBug[64];
		sprintf(szBug, "GetLastErrorText: error = %ld", dwInternalErrorCode);
		MessageBox(NULL, szBug, "GetLastErrorText()", MB_OK | MB_TOPMOST);

#endif

		if (pMessageText != NULL) LocalFree(pMessageText);
		return "";
	}
	if (pMessageText != NULL)
	{
		strMessage = pMessageText;
		LocalFree(pMessageText);

//	Since these messages usually have a trailing "\r\n" which is redundant in
//	our application, strip the last two characters from the text if they're
//	"\r\n"; otherwise leave the text alone.

		if ((nIndex = strMessage.ReverseFind('\r')) == (strMessage.GetLength() - 2))
		{
			strMessage = strMessage.Left(nIndex);
		}
		return strMessage;
	}
	else
	{
		return "";
	}
}


CString	GetLastErrorText()
{
	return GetLastErrorText(GetLastError());
}
