// onfigDlg.cpp : implementation file
//

#include "stdafx.h"
#define	EXTERN extern
#include "virtual_h8.h"
#include "ConfigDlg.h"
#include "ini_file.h"
#include "globals.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ConfigDlg dialog


ConfigDlg::ConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(ConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ConfigDlg)
	m_bGreen = FALSE;
	m_bReverse = FALSE;
	m_bAnsi = FALSE;
	m_bAutoCR = FALSE;
	m_nCursorType = -1;
	m_nLineWrapMode = -1;
	m_bShifted = FALSE;
	//}}AFX_DATA_INIT
}


void ConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ConfigDlg)
	DDX_Check(pDX, IDC_GREEN, m_bGreen);
	DDX_Check(pDX, IDC_REVERSE, m_bReverse);
	DDX_Check(pDX, IDC_ANSI, m_bAnsi);
	DDX_Check(pDX, IDC_AUTO_CR, m_bAutoCR);
	DDX_Radio(pDX, IDC_CURSOR_TYPE1, m_nCursorType);
	DDX_Radio(pDX, IDC_NO_WRAP, m_nLineWrapMode);
	DDX_Check(pDX, IDC_SHIFTED, m_bShifted);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ConfigDlg, CDialog)
	//{{AFX_MSG_MAP(ConfigDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ConfigDlg message handlers

void ConfigDlg::OnOK() 
{
	UpdateData(TRUE);
	WritePrivateProfileString(INI_KEY_REVERSE_VIDEO,
								m_bReverse ? "1" : "0",
								(LPCSTR) m_strPath);
	WritePrivateProfileString(INI_KEY_GREEN_CRT,
								m_bGreen ? "1" : "0",
								(LPCSTR) m_strPath);
	WritePrivateProfileString(INI_KEY_ANSI_MODE,
								m_bAnsi ? "1" : "0",
								(LPCSTR) m_strPath);
	WritePrivateProfileString(INI_KEY_AUTO_CR,
								m_bAutoCR ? "1" : "0",
								(LPCSTR) m_strPath);
	WritePrivateProfileString(INI_KEY_KEYPAD_SHIFTED,
								m_bShifted ? "1" : "0",
								(LPCSTR) m_strPath);
	WritePrivateProfileString(INI_KEY_UNDERSCORE_CURSOR,
								m_nCursorType ? "0" : "1",
								(LPCSTR) m_strPath);
	WritePrivateProfileString(INI_KEY_WRAP,
								m_nLineWrapMode ? "1" : "0",
								(LPCSTR) m_strPath);
	CDialog::OnOK();
}

BOOL ConfigDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_bReverse = GetPrivateProfileInt(INI_KEY_REVERSE_VIDEO,
								FALSE,
								(LPCSTR) m_strPath);

#ifndef STRICT_EMULATION

	GetDlgItem(IDC_GREEN) -> ShowWindow(SW_HIDE);
	m_bGreen = FALSE;

#else

	m_bGreen = GetPrivateProfileInt(INI_KEY_GREEN_CRT,
								FALSE,
								(LPCSTR) m_strPath);

#endif

#if 0	//	We don't yet recognize ANSI escapes: there would be no way to get out

	m_bAnsi = GetPrivateProfileInt(INI_KEY_ANSI_MODE,
								FALSE,
								(LPCSTR) m_strPath);

#else

	m_bAnsi = FALSE;
	GetDlgItem(IDC_ANSI) -> EnableWindow(FALSE);

#endif

	m_bAutoCR = GetPrivateProfileInt(INI_KEY_AUTO_CR,
								FALSE,
								(LPCSTR) m_strPath);
	m_bShifted = GetPrivateProfileInt(INI_KEY_KEYPAD_SHIFTED,
								FALSE,
								(LPCSTR) m_strPath);
	m_nCursorType = !(GetPrivateProfileInt(INI_KEY_UNDERSCORE_CURSOR,
								0,							// This will default to block cursor
								(LPCSTR) m_strPath) % 2);
	m_nLineWrapMode = (GetPrivateProfileInt(INI_KEY_WRAP,
								1,
								(LPCSTR) m_strPath) % 2);
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
