/************************************************************************
 *																		*
 *	Copyright (c) 2000 - 2001 by	David A. Wallace					*
 *									154 Dunstable Rd.					*
 *									N. Chelmsford, MA					*
 *											01863-1202					*
 *																		*
 ************************************************************************/


#include "stdafx.h"
#define	EXTERN extern
#include "virtual_h8.h"
#include "virtual_h8Doc.h"
#include "virtual_h8View.h"
#include "globals.h"
#include "ScreenWindow.h"
#include "syspalette.h"
#include "resource.h"
#include "ini_file.h"
#include "msgs.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;

#define SetCharacter(l, c, d, a)	m_cRaster[(l)-1][(c)-1][0] = (d);\
									m_cRaster[(l)-1][(c)-1][1] = (char) (a);\
									DrawAt((l) - 1, (c) - 1);
#endif

#ifndef STRICT_EMULATION
#define	ZEROTH_GRAPHIC_CHAR '@'
#else
#define	ZEROTH_GRAPHIC_CHAR '^'
#endif

/////////////////////////////////////////////////////////////////////////////
// ScreenWindow - constructor and destructor, message map

ScreenWindow::ScreenWindow()
{
	m_bmpCharacterSet.LoadBitmap(IDB_CHARSET);
	m_bReverseVideo = FALSE;
	m_bMemDCCreated = FALSE;
	SetPowerupConfiguration(FALSE);
	m_dMagnification = 1;
	m_bEnhancedEmulation =

#ifndef STRICT_EMULATION

		TRUE;

#else

		FALSE;

#endif

}


ScreenWindow::~ScreenWindow()
{
}


BEGIN_MESSAGE_MAP(ScreenWindow, CWnd)
	//{{AFX_MSG_MAP(ScreenWindow)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// ScreenWindow message handlers -- called to paint the display.


BOOL ScreenWindow::OnEraseBkgnd(CDC* pDC) 
{
	CRect		rWin;
	CPen *		pPen1 = (CPen *) new CPen(PS_SOLID, 0, Palette.crButtonShadow);
	CPen *		pPen2 = (CPen *) new CPen(PS_SOLID, 0, Palette.crButtonFace);
	CPen *		pHighlightPen = (CPen *) new CPen(PS_SOLID, 6, Palette.crButtonHilight);
	int			nCXScreen;
	int			nCYScreen;
	CBitmap *	pBitmap = NULL;
	CBitmap *	pOldBitmap = NULL;
	BOOL		bResult;
	CRect		rWnd;

	GetClientRect(&rWnd);
	rWnd.top += (int) (((double) SCREEN_VERT_BORDER) * m_dMagnification);
	rWnd.bottom -= (int) (((double) SCREEN_VERT_BORDER) * m_dMagnification);
	rWnd.left += (int) (((double) SCREEN_HORIZ_BORDER) * m_dMagnification);
	rWnd.right -= (int) (((double) SCREEN_HORIZ_BORDER) * m_dMagnification);

//      Clear the window to black, except for a 6-pixel border of white.  

	_ASSERTE(SCREEN_HORIZ_BORDER == 9);
	_ASSERTE(SCREEN_VERT_BORDER == 9);
        
	GetClientRect(&rWin);
	nCXScreen = rWin.right - rWin.left;
	nCYScreen = rWin.bottom - rWin.top;
	pDC -> SelectObject(pHighlightPen);
	pDC -> MoveTo(3, 3);
	pDC -> LineTo(nCXScreen - 3, 3);
	pDC -> LineTo(nCXScreen - 3, nCYScreen - 3);
	pDC -> LineTo(3, nCYScreen - 3);
	pDC -> LineTo(3, 3);
	pDC -> SelectStockObject(BLACK_PEN);
	if (m_bReverseVideo)
	{

		if (m_bGreenCRT)
		{
			pDC -> SelectStockObject(BLACK_BRUSH);
		}
		else
		{
			pDC -> SelectStockObject(WHITE_BRUSH);
		}
	}
	else
	{
		pDC -> SelectStockObject(BLACK_BRUSH);
	}
	pDC -> Rectangle(4, 4, nCXScreen - 4, nCYScreen - 4);

//		Now add a 3-d look by shadwing the borders of the window.

	pDC -> SelectObject(pPen1);
	pDC -> MoveTo(0, nCYScreen - 1);
	pDC -> LineTo(0, 0);
	pDC -> LineTo(nCXScreen - 1, 0);
	pDC -> MoveTo(1, nCYScreen - 2);
	pDC -> LineTo(1, 1);
	pDC -> LineTo(nCXScreen - 2, 1);
	pDC -> SelectObject(pPen2);
	pDC -> MoveTo(1, nCYScreen - 2);
	pDC -> LineTo(nCXScreen - 2, nCYScreen - 2);
	pDC -> LineTo(nCXScreen - 2, 0);
	pDC -> MoveTo(2, nCYScreen - 3);
	pDC -> LineTo(nCXScreen - 3, nCYScreen - 3);
	pDC -> LineTo(nCXScreen - 3, 1);
	pDC -> SelectObject(pPen2);
	pDC -> MoveTo(0, nCYScreen);
	pDC -> LineTo(nCXScreen, nCYScreen);
	pDC -> LineTo(nCXScreen, 0);
	pDC -> SelectStockObject(BLACK_PEN);
	pDC -> MoveTo(2, nCYScreen - 3);
	pDC -> LineTo(2, 2);
	pDC -> LineTo(nCXScreen - 3, 2);
	pDC -> MoveTo(3, nCYScreen - 3);
	pDC -> LineTo(3, 3);
	pDC -> LineTo(nCXScreen - 3, 3);
	DeleteObject(pPen1);
	DeleteObject(pPen2);
	DeleteObject(pHighlightPen);
	delete pPen1;
	delete pPen2;
	delete pHighlightPen;
	if (!m_bMemDCCreated)
	{

//	Create a compatible memDC bitmap the size of our window.  Make it all black.


		if (!m_MemDC.CreateCompatibleDC(pDC))
		{
			AfxMessageBox("Create MEM DC");
		}
		for (m_nPlanes = 3; m_nPlanes > 0; --m_nPlanes)
		{
			for (m_nBits = 12; m_nBits > 0; --m_nBits)
			{
				pBitmap = (CBitmap *) new CBitmap;
				bResult = pBitmap -> CreateBitmap(rWnd.Width(),
													rWnd.Height(),
													m_nPlanes,
													m_nBits,
													NULL);
				if (!bResult)
				{
					delete pBitmap;
					pBitmap = NULL;
					continue;
				}
				pOldBitmap = m_MemDC.SelectObject(pBitmap);
				if (pOldBitmap != NULL) break;
				delete pBitmap;
			}
			if (pOldBitmap != NULL) break;
		}
		if (pBitmap != NULL)
		{
			DeleteObject(pBitmap);
			delete pBitmap;
		}
		m_MemDC.SelectStockObject(BLACK_PEN);
		m_MemDC.SelectStockObject(BLACK_BRUSH);
		m_MemDC.Rectangle(0, 0, rWnd.Width() + 1, rWnd.Height() + 1);
		if (!m_ChargenDC.CreateCompatibleDC(pDC))
		{
			AfxMessageBox("Create Character Generator DC");
		}
		else if (!m_ChargenDC.SelectObject(&m_bmpCharacterSet))
		{
			AfxMessageBox("Select Bitmap Object");
		}
		else if (!m_CellDC.CreateCompatibleDC(pDC))
		{
			AfxMessageBox("Create Character Cell DC");
		}
		else if (!m_GreenDC.CreateCompatibleDC(pDC))
		{
			AfxMessageBox("Create Green Character Cell DC");
		}
		else if (!m_FgDC.CreateCompatibleDC(pDC))
		{
			AfxMessageBox("Create FG Character Cell DC");
		}
		else if (!m_BgDC.CreateCompatibleDC(pDC))
		{
			AfxMessageBox("Create BG Character Cell DC");
		}
		else m_bMemDCCreated = TRUE;
	}
	return TRUE;
}


//	OnPaint() will recompute the entire display area using a memory context and
//	will then paint the display area of our window from the memory context by
//	calling BitBlt().

void ScreenWindow :: OnPaint() 
{
	CPaintDC	dc(this);
	CRect		rWnd;

	GetClientRect(&rWnd);
	rWnd.top += (int) (((double) SCREEN_VERT_BORDER) * m_dMagnification);
	rWnd.bottom -= (int) (((double) SCREEN_VERT_BORDER) * m_dMagnification);
	rWnd.left += (int) (((double) SCREEN_HORIZ_BORDER) * m_dMagnification);
	rWnd.right -= (int) (((double) SCREEN_HORIZ_BORDER) * m_dMagnification);
	if (m_bMemDCCreated)
	{

//	BitBlt the memDC onto our device context.  The memDC is an exact image
//	of the screen, so just copy it.

		dc.BitBlt(rWnd.left,
					rWnd.top,
					rWnd.Width(),
					rWnd.Height(),
					&m_MemDC,
					0,
					0,
					SRCCOPY);
	}
}


//	Extract the character from the character generator rom, apply the cursor,
//	apply the colors and StretchBlt it onto the supplied (memory) device context.
//	Note: the Line and Column arguments for this function are zero-based.

void	ScreenWindow :: DrawAt(int nLine, int nColumn, BOOL	bRepaint)
{
	CRect		rCell;
	CRect		rCursor;
	CRect		rScreen;
	BOOL		bCursorState;
	CBitmap 	myBitmap;
	CBitmap		greenBitmap;
	CRect		rWnd;
	CBrush *	pGreenBrush;
	COLORREF	crFg;
	CBrush *	pFgBrush;
	CBitmap		fgBitmap;
	COLORREF	crBg;
	CBrush *	pBgBrush;
	CBitmap		bgBitmap;

	if (m_bMemDCCreated)
	{
		GetClientRect(&rWnd);
		rWnd.top += (int) (((double) SCREEN_VERT_BORDER) * m_dMagnification);
		rWnd.bottom -= (int) (((double) SCREEN_VERT_BORDER) * m_dMagnification);
		rWnd.left += (int) (((double) SCREEN_HORIZ_BORDER) * m_dMagnification);
		rWnd.right -= (int) (((double) SCREEN_HORIZ_BORDER) * m_dMagnification);
		bCursorState = (!m_bInhibitCursor) &&
								((m_bShowCursor && m_bCursorBlinkState) &&
								(m_nCursorLine == (nLine + 1)) &&
								(m_nCursorColumn == (nColumn + 1)));
		myBitmap.CreateBitmap(CHAR_GEN_WIDTH,
								CHAR_GEN_HEIGHT,
								m_nPlanes,
								m_nBits,
								NULL);
		m_CellDC.SelectObject(&myBitmap);

		if (!m_b25thLineMode && (nLine == 24))
		{
			rCell = CharacterGeneratorCoordinates(' ', (char) 0);
		}
		else
		{
			rCell = CharacterGeneratorCoordinates(m_cRaster[nLine][nColumn][0],
													m_cRaster[nLine][nColumn][1]);
		}
		m_CellDC.SelectStockObject(BLACK_PEN);
		m_CellDC.SelectStockObject(BLACK_BRUSH);
		m_CellDC.Rectangle(0, 0, CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT);
		m_CellDC.BitBlt(0, 0,
						CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT,
						&m_ChargenDC,
						rCell.left, rCell.top, 
						SRCCOPY);
		rCursor = m_bCursorIsBlock ?
					CRect(0, 0, CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT) :
					CRect(0,
							8,
							CHAR_GEN_WIDTH,
							9);
		if (bCursorState)
		{
			m_CellDC.InvertRect(rCursor);
		}
		if (m_cRaster[nLine][nColumn][1] & ATTRIB_INVERSE)
		{
			m_CellDC.InvertRect(CRect(0, 0, CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT));
		}
		rScreen = DisplayCoordinates(nLine, nColumn);
		if (!m_bReverseVideo)
		{
			m_CellDC.InvertRect(CRect(0, 0, CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT));
		}

//	In Enhanced emulation mode, we use m_FgDC and m_BgDC to form the character.
//	In Green Screen mode we use m_GreenDC to modify the character's basic color.
//	In "standard" mode, we simply use m_CellDC alone.

		if (m_bEnhancedEmulation)
		{
			crFg = RGB(((m_cRaster[nLine][nColumn][1] & ATTRIB_RED_FG) ? 255 : 0),
						((m_cRaster[nLine][nColumn][1] & ATTRIB_GREEN_FG) ? 255 : 0),
						((m_cRaster[nLine][nColumn][1] & ATTRIB_BLUE_FG) ? 255 : 0));
			crBg = RGB(((m_cRaster[nLine][nColumn][1] & ATTRIB_RED_BG) ? 255 : 0),
						((m_cRaster[nLine][nColumn][1] & ATTRIB_GREEN_BG) ? 255 : 0),
						((m_cRaster[nLine][nColumn][1] & ATTRIB_BLUE_BG) ? 255 : 0));
			fgBitmap.CreateBitmap(CHAR_GEN_WIDTH,
										CHAR_GEN_HEIGHT,
										m_nPlanes,
										m_nBits,
										NULL);
			if (!m_FgDC.SelectObject(&fgBitmap))
			{
				AfxMessageBox("Select fg Bitmap object.");
			}
			pFgBrush = new CBrush(crFg);
			if (!m_FgDC.SelectObject(pFgBrush))
			{
				AfxMessageBox("Selecting fg brush.");
			}
			m_FgDC.SelectStockObject(NULL_PEN);
			m_FgDC.Rectangle(0, 0, CHAR_GEN_WIDTH + 1, CHAR_GEN_HEIGHT + 1);
			bgBitmap.CreateBitmap(CHAR_GEN_WIDTH,
										CHAR_GEN_HEIGHT,
										m_nPlanes,
										m_nBits,
										NULL);
			if (!m_BgDC.SelectObject(&bgBitmap))
			{
				AfxMessageBox("Select Green Bitmap object.");
			}
			pBgBrush = new CBrush(crBg);
			if (!m_BgDC.SelectObject(pBgBrush))
			{
				AfxMessageBox("Selecting bg brush.");
			}
			m_BgDC.SelectStockObject(NULL_PEN);
			m_BgDC.Rectangle(0, 0, CHAR_GEN_WIDTH + 1, CHAR_GEN_HEIGHT + 1);

//	Enhanced emulation -- we must make the character fg on bg and use
//	SRCCOPY always when StretchBlt-ing.

			m_FgDC.BitBlt(0, 0,
							CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT, 
							&m_CellDC,
							0, 0,
							SRCAND);
			m_CellDC.InvertRect(CRect(0, 0, CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT));
			m_BgDC.BitBlt(0, 0,
							CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT, 
							&m_CellDC,
							0, 0,
							SRCAND);
			m_CellDC.BitBlt(0, 0,
							CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT, 
							&m_FgDC,
							0, 0,
							SRCCOPY);
			m_CellDC.BitBlt(0, 0,
							CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT, 
							&m_BgDC,
							0, 0,
							SRCPAINT);
			m_MemDC.StretchBlt(rScreen.left, rScreen.top,
								rScreen.Width(), rScreen.Height(),
								&m_CellDC,
								0, 0,
								CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT,
								SRCCOPY);
			DeleteObject(pFgBrush);
			delete pFgBrush;
			DeleteObject(pBgBrush);
			delete pBgBrush;
			DeleteObject(&fgBitmap);
			DeleteObject(&bgBitmap);
		}
		else if (m_bGreenCRT)
		{
			greenBitmap.CreateBitmap(CHAR_GEN_WIDTH,
										CHAR_GEN_HEIGHT,
										m_nPlanes,
										m_nBits,
										NULL);
			if (!m_GreenDC.SelectObject(&greenBitmap))
			{
				AfxMessageBox("Select Green Bitmap object.");
			}
			pGreenBrush = new CBrush(RGB(0, 255, 0));
			if (!m_GreenDC.SelectObject(pGreenBrush))
			{
				AfxMessageBox("Selecting green brush.");
			}
			m_GreenDC.SelectStockObject(NULL_PEN);
			m_GreenDC.Rectangle(0, 0, CHAR_GEN_WIDTH + 1, CHAR_GEN_HEIGHT + 1);

//	For green screen mode, we must make the character green-on-black (or
//	black-on-green) and use SRCCOPY always when StretchBlt-ing.

			m_GreenDC.BitBlt(0, 0,
							CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT, 
							&m_CellDC,
							0, 0,
							SRCAND);
			m_MemDC.StretchBlt(rScreen.left, rScreen.top,
								rScreen.Width(), rScreen.Height(),
								&m_GreenDC,
								0, 0,
								CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT,
								SRCCOPY);
			DeleteObject(pGreenBrush);
			delete pGreenBrush;
			DeleteObject(&greenBitmap);
		}
		else
		{
			m_MemDC.StretchBlt(rScreen.left, rScreen.top,
								rScreen.Width(), rScreen.Height(),
								&m_CellDC,
								0, 0,
								CHAR_GEN_WIDTH, CHAR_GEN_HEIGHT,
								SRCCOPY);
		}
		DeleteObject(&myBitmap);
		DeleteObject(&m_bmpCharacterSet);
		if (bRepaint)
		{
			rScreen.right += rWnd.left;
			rScreen.left += rWnd.left;
			rScreen.bottom += rWnd.top;
			rScreen.top += rWnd.top;
			RedrawWindow(&rScreen, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_NOERASE );
		}
	}
}


//	RedrawCursor() -- repaint the character at the cursor.

void	ScreenWindow :: RedrawCursor()
{
	DrawAt(m_nCursorLine - 1, m_nCursorColumn - 1);
}


//	RepaintScreen: repaint the entire display.

void	ScreenWindow :: RepaintScreen()
{
	int	nI;

	for (nI = 1; nI <= 25; ++nI)
	{
		RepaintLine(nI, FALSE);
	}
	RedrawWindow();
}



//	Repaint all the characters of the specified line.

void	ScreenWindow :: RepaintLine(int nLine, BOOL bRepaint)
{
	CRect	rScreen;
	CRect	rWnd;
	int		nI;

//	BitBlt the whole line and then update in one swell foop.

	for (nI = 0; nI < 80; nI++)
	{
		DrawAt(nLine - 1, nI, FALSE);
	}
	if (bRepaint)
	{	
		GetClientRect(&rWnd);
		rWnd.top += (int) (((double) SCREEN_VERT_BORDER) * m_dMagnification);
		rWnd.bottom -= (int) (((double) SCREEN_VERT_BORDER) * m_dMagnification);
		rWnd.left += (int) (((double) SCREEN_HORIZ_BORDER) * m_dMagnification);
		rWnd.right -= (int) (((double) SCREEN_HORIZ_BORDER) * m_dMagnification);
		rScreen = DisplayCoordinates(nLine - 1, 0);
		rScreen.right = DisplayCoordinates(nLine - 1, 79).right;
		rScreen.right += rWnd.left;
		rScreen.left += rWnd.left;
		rScreen.bottom += rWnd.top;
		rScreen.top += rWnd.top;
		RedrawWindow(&rScreen);
	}
}


void	ScreenWindow :: MoveScreen(int nFirstLine, int nLastLine, int nDirection)
{
	CRect	rWnd;
	CDC *	pDC = GetDC();
	int		nFirstRaster = (nFirstLine - 1) * CHAR_HEIGHT;
	int		nLastRaster = (nLastLine) * CHAR_HEIGHT;
	int		nDisplacement;

	if (nDirection < 0) nDisplacement = -CHAR_HEIGHT;
	else nDisplacement = CHAR_HEIGHT;
	if (m_bMemDCCreated)
	{
		GetClientRect(&rWnd);
		rWnd.top += (int) (((double) SCREEN_VERT_BORDER) * m_dMagnification);
		rWnd.bottom -= (int) (((double) SCREEN_VERT_BORDER) * m_dMagnification);
		rWnd.left += (int) (((double) SCREEN_HORIZ_BORDER) * m_dMagnification);
		rWnd.right -= (int) (((double) SCREEN_HORIZ_BORDER) * m_dMagnification);

//	Move the memory bitmap nDisplacement over the range (nLastRaster - nFirstRaster)
//	starting with nFirstRaster and targeting nFirstRaster + nDisplacement.

		m_MemDC.BitBlt(0, nFirstRaster + nDisplacement,
							rWnd.Width(), (nLastRaster - nFirstRaster),
							&m_MemDC,
							0, nFirstRaster,
							SRCCOPY);

//	Copy the whole bitmap to the screen.

		pDC -> BitBlt(rWnd.left, rWnd.top,
							rWnd.Width(), rWnd.Height(),
							&m_MemDC,
							0, 0,
							SRCCOPY);
	}
}

////////////////////////////////////////////////////////////////////////////////
//	Subroutines needed by the display painting code above:


//	CharacterGeneratorCoordinates takes the ASCII character and returns the
//	rectanguar area which contains the bits that draw the character.  Needs a
//	little work -- it returns a zero-size rectangle if the character isn't
//  printable; the client must test for that.

CRect	ScreenWindow::CharacterGeneratorCoordinates(char cData, char cAttribute)
{

//	The "character generator" is a bitmap which contains 8x10 bitmaps for
//	5 lines of 32 characters each, in ASCII order, starting with ' '.
//	For normal ascii characters, the index is 8 * (cData - ' ') % 32 for the
//	X coordinate and 10 * (cData - ' ') / 32 for the Y coordinate.  For the
//	graphic characters, the index is 8 * (cData - '^' + 96) % 32 for the
//	X coordinate and 10 * (cData - '^' + 96) / 32 for the Y coordinate.
//	(The fourth line of characters contains only the graphical symbols for '^'
//	and '_'.  There was an opportunity here to define another 30 graphics and
//	assign them to some other characters -- I couldn't resist!)

	int	nIndex;
	int	nX;
	int	nY;

//	Non-printing characters always return a rectangle of size zero.  The client
//	code should check for that.

	if (!isprint(cData)) return CRect(0,0,0,0);

//	The H-19 graphic characters started at 94 ('^') and ran in order through
//	126 ('~').

//	I couldn't resist an "enhancement": I've defined the following additional
//	graphic characters:
//
//	character		graphic
//
//		@			cap-a-macron
//		A			a-macron
//		B			
//		C			
//		D			cap-e-macron
//		E			e-macron
//		F			
//		G			
//		H			cap-i-macron
//		I			i-macron
//		J			
//		K			
//		L			
//		M			
//		N			cap-o-macron
//		O			o-macron
//		P
//		Q
//		R			degree symbol
//		S			pi
//		T			cap-u-macron
//		U			u-macron
//		V			mu
//		W			`okina				(What can I say? I'm learning Hawaiian!)
//		X			root symbol (or checkmark)
//		Y			left arrow
//		Z			up arrow
//		[			copyright symbol
//		\			pillow
//		]			cent-sign
//
//	There are still 10 undefined graphic positions.  These are filled with an
//	inverted question-mark (like preceeds a question in Spanish).  The two
//	"impossible" characters -- DEL and graphic-DEL are filled with a special
//	symbol: one or two dots inside a box.  (If these "domino" characters ever
//	appear on-screen it means the code below is broken.)
//
//	This enhancement will be invisible if running standard Heathkit software. It
//	can be disabled by defining the symbol STRICT_EMULATION.
//
//	If the character is outside the currently-chosen graphic character range, it
//	will be treated as a non-graphic.

	if (cAttribute & ATTRIB_GRAPHIC)
	{
		nIndex = cData - ZEROTH_GRAPHIC_CHAR;

//	There are a possible 30 additional graphic characters that could be defined
//	(with special coding of the nIndex computation), but we presently don't.

		if (nIndex < 0)
		{
			nIndex = cData - ' ';
		}
		else
		{

//	The graphics characters start in position 96.

			nIndex += 96 + ZEROTH_GRAPHIC_CHAR - '@';
		}
	}
	else
	{
		nIndex = cData - ' ';
	}
	nX = nIndex % 32;
	nY = nIndex / 32;
	nX *= CHAR_GEN_WIDTH;
	nY *= CHAR_GEN_HEIGHT;
	return CRect(nX, nY, nX + CHAR_GEN_WIDTH, nY + CHAR_GEN_HEIGHT);
}



//	DisplayCoordinates takes the screen position and returns the rectangular
//	area of the bitmap corresponding to that cell.

CRect	ScreenWindow::DisplayCoordinates(int nLine, int nChar)
{
	int	nX = (int) ((double) nChar * ((double) CHAR_WIDTH) * m_dMagnification);
	int	nY = (int) ((double) nLine * ((double) CHAR_HEIGHT) * m_dMagnification);

	return CRect(nX, nY,
					nX + (int) (((double) CHAR_WIDTH) * m_dMagnification),
					nY + (int) (((double) CHAR_HEIGHT) * m_dMagnification));
}


#ifdef _DEBUG

////////////////////////////////////////////////////////////////////////////////
//	Some functions to help debug the display painting code:


//	DisplayTest: set up the display array to have some stuff in it.
//	Also, inhibit cursor.

void ScreenWindow :: DisplayTest()
{

//	test: initialize the screen window to display a test pattern.

	RedrawWindow();	//	force create of m_MemDC
	SetPowerupConfiguration();
	SetTextLine(1, "The Heathkit H-19 Terminal");
	SetTextLine(2, " 2.......x.........x.........x.........x"
							".........L.........x.........x.........X");
	SetTextLine(3, " 3");
	SetTextLine(4, " 4    The H-19 terminal displays 25 lines of 80 characters each.  Normally,");
	SetTextLine(5, " 5    line 25 is used as a \"status\" line, since it does not scroll with the");
	SetTextLine(6, " 6    others and can be turned on and off.  The H-19 character attributes");
	SetTextLine(7, " 7    are NORMAL, INVERSE, GRAPHIC and INVERSE GRAPHIC.");
	SetTextLine(8, " 8");
	SetTextLine(9, " 9");
	SetInverseTextLine(10, "10      `1234567890-=\\~!@#$%^&*()_+|"
							"qwertyuiop[]QWERTYUIOP{}asdfghjkl;'");
	SetTextLine(11, "11");
#if defined(STRICT_EMULATION)
	SetTextLine(12, "12");
	SetTextLine(13, "13");
	SetTextLine(14, "14                      !\"#$%&'()*+,-./0123456789:;<=>?");
	SetTextLine(15, "15                     @ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_");
	SetTextLine(16, "16                     `abcdefghijklmnopqrstuvwxyz{|}~");
	SetTextLine(17, "17");
	SetTextLine(18, "18");
#else
	SetTextLine(12, "12                      !\"#$%&'()*+,-./0123456789:;<=>?");
	SetTextLine(13, "13                     @ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_");
	SetTextLine(14, "14                     `abcdefghijklmnopqrstuvwxyz{|}~");
	SetTextLine(15, "15");
	SetTextLine(16, "16 I have enhanced the emulator to include extra graphics characters and color:");
	SetTextLine(17, "17                         @ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]");
	SetTextLine(18, "18");
	SetCharacter(18, 28, '@', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 29, 'A', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 30, 'B', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 31, 'C', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 32, 'D', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 33, 'E', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 34, 'F', ATTRIB_GRAPHIC + 0x1C);	//	white in black
	SetCharacter(18, 35, 'G', ATTRIB_GRAPHIC + 0x3C);	//	white in blue
	SetCharacter(18, 36, 'H', ATTRIB_GRAPHIC + 0x5C);	//	white in red
	SetCharacter(18, 37, 'I', ATTRIB_GRAPHIC + 0x7C);	//	white in magenta
	SetCharacter(18, 38, 'J', ATTRIB_GRAPHIC + 0x9C);	//	white in green
	SetCharacter(18, 39, 'K', ATTRIB_GRAPHIC + 0xBC);	//	white in cyan
	SetCharacter(18, 40, 'L', ATTRIB_GRAPHIC + 0xDC);	//	white in yellow
	SetCharacter(18, 41, 'M', ATTRIB_GRAPHIC + 0x04);	//	blue in black
	SetCharacter(18, 42, 'N', ATTRIB_GRAPHIC + 0x08);	//	red in black 
	SetCharacter(18, 43, 'O', ATTRIB_GRAPHIC + 0x0C);	//	magenta in black
	SetCharacter(18, 44, 'P', ATTRIB_GRAPHIC + 0x10);	//	green in black
	SetCharacter(18, 45, 'Q', ATTRIB_GRAPHIC + 0x14);	//	cyan in black
	SetCharacter(18, 46, 'R', ATTRIB_GRAPHIC + 0x18);	//	yellow in black
	SetCharacter(18, 47, 'S', ATTRIB_GRAPHIC + 0x2C);	//	magenta in blue
	SetCharacter(18, 48, 'T', ATTRIB_GRAPHIC + 0x28);	//	red in blue
	SetCharacter(18, 49, 'U', ATTRIB_GRAPHIC + 0xA4);	//	blue in cyan
	SetCharacter(18, 50, 'V', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 51, 'W', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 52, 'X', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 53, 'Y', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 54, 'Z', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 55, '[', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 56, '\\', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(18, 57, ']', ATTRIB_GRAPHIC + 0x1C);
#endif
	SetTextLine(19, "19");
	SetInverseTextLine(20, "20    ASDFGHJKL:\"zxcvbnm,./ZXCVBNM<>?");
	SetCharacter(20, 46, '^', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 47, '_', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 48, '`', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 49, 'a', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 50, 'b', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 51, 'c', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 52, 'd', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 53, 'e', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 54, 'f', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 55, 'g', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 56, 'h', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 57, 'i', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 58, 'j', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 59, 'k', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 60, 'l', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 61, 'm', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 62, 'n', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 63, 'o', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 64, 'p', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 65, 'q', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 66, 'r', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 67, 's', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 68, 't', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 69, 'u', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 70, 'v', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 71, 'w', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 72, 'x', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 73, 'y', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 74, 'z', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 75, '{', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 76, '|', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 77, '}', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetCharacter(20, 79, '~', ATTRIB_GRAPHIC | ATTRIB_INVERSE + 0x1C);
	SetTextLine(21, "21");
	SetTextLine(22, "22        This emulation uses a \"character generator ROM\" bitmap object");
	SetTextLine(23, "23         to create the proper pattern of pixels for each character.");
	SetTextLine(24, "24");
	SetTextLine(25, "         ^ _ ` a b c d e f g h i j k l m n o p q r s t u v w x y z { | } ~");
	SetCharacter(25, 1, '2', 0x1C);
	SetCharacter(25, 2, '5', 0x1C);
	SetCharacter(25, 11, '^', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 13, '_', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 15, '`', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 17, 'a', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 19, 'b', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 21, 'c', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 23, 'd', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 25, 'e', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 27, 'f', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 29, 'g', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 31, 'h', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 33, 'i', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 35, 'j', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 37, 'k', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 39, 'l', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 41, 'm', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 43, 'n', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 45, 'o', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 47, 'p', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 49, 'q', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 51, 'r', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 53, 's', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 55, 't', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 57, 'u', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 59, 'v', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 61, 'w', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 63, 'x', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 65, 'y', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 67, 'z', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 69, '{', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 71, '|', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 73, '}', ATTRIB_GRAPHIC + 0x1C);
	SetCharacter(25, 75, '~', ATTRIB_GRAPHIC + 0x1C);
	RepaintScreen();
}


//	SetTextLine: writes a string in NORMAL attribute with default colors --
//	fills remainder of the line with spaces.  This routine is strictly for testing!

void	ScreenWindow :: SetTextLine(int nLine, char * szData)
{
	unsigned int	nI;
	unsigned int	nJ;

//	Set an entire line of text (by far the most common operation).
//	Line ends with '\0' -- rest of line is blanked.

	for (nI = 0, nJ = 0; nI < 80; ++nI)
	{
		if (nJ < strlen(szData))
			m_cRaster[nLine - 1][nI][0] = szData[nJ++];
		else
			m_cRaster[nLine - 1][nI][0] = ' ';
		m_cRaster[nLine - 1][nI][1] = (char) ((m_nFG * 4) + (m_nBG * 16));
	}
	RepaintLine(nLine);
}


//	SetInverseTextLine: writes a string in INVERT attribute with default colors --
//	fills remainder of the line with spaces.  This routine is strictly for testing!

void	ScreenWindow :: SetInverseTextLine(int nLine, char * szData)
{
	unsigned int	nI;
	unsigned int	nJ;

//	Set an entire line of text (by far the most common operation).
//	Line ends with '\0' -- rest of line is blanked.

	for (nI = 0, nJ = 0; nI < 80; ++nI)
	{
		if (nJ < strlen(szData))
			m_cRaster[nLine - 1][nI][0] = szData[nJ++];
		else
			m_cRaster[nLine - 1][nI][0] = ' ';
		m_cRaster[nLine - 1][nI][1] =
			(char) (ATTRIB_INVERSE + (m_nFG * 4) + (m_nBG * 16));
	}
	RepaintLine(nLine);
}

#endif


////////////////////////////////////////////////////////////////////////////////
//
//	The rest of this code deals with terminal emulation: character and cursor
//	handling and I/O


//	SetPowerupConfiguration: in response to construction or to reset, we set
//	mode bits and clear the screen like we would at power-up.

void	ScreenWindow :: SetPowerupConfiguration(BOOL bRedraw)
{
	char	szWd[MAX_PATH];
	CString	strIniFile;
	
	m_nBG = 0;							//	black background
	m_nFG = 7;							//	white characters
	GetCurrentDirectory(MAX_PATH, szWd);
	strIniFile = szWd;
	strIniFile +=	"\\" INI_FILE_NAME;

//	Video options -- reversed polarity and green phosphor

	m_bReverseVideo =
		GetPrivateProfileInt(INI_KEY_REVERSE_VIDEO,
								FALSE,					//	white on black, normally
								(LPCSTR) strIniFile);
	m_bGreenCRT = GetPrivateProfileInt(INI_KEY_GREEN_CRT,
										FALSE,
										(LPCSTR) strIniFile);

//	The following features were controlled by a dip-switch:
//		Switch Section Setting Description 
//		0				Up (0) Underscore Cursor 
//					*	Down (1) Block Cursor 
//		2				Up (0) Discard past end-of-line
//						(no Auto-carry at end of line) 
//					*	Down (1) Wrap Around (Auto-Carry at end of line) 
//		4			*	Up (0) No Auto CR on LF 
//						Down (1) Auto CR on LF 
//		5			*	Up (0) Heath Escape Mode 
//						Down (1) ANSI Escape Mode 
//		6			*	Up (0) Keypad Normal (Enters numbers when
//						key is pressed.) 
//						Down (1) Keypad Shifted (Enters display manipulation
//						commands when a keypad key is pressed.) 
//	[Sections 1 and 7 controlled features not emulated -- key click and refresh
//	rate.]

	m_bCursorIsBlock = 
		!GetPrivateProfileInt(INI_KEY_UNDERSCORE_CURSOR,
								FALSE,					//	default cursor is block
								(LPCSTR) strIniFile);
	m_bWrapMode = 
		GetPrivateProfileInt(INI_KEY_WRAP,
								TRUE,					//	wrap text at end of line
								(LPCSTR) strIniFile);
	m_bAutoCR = 
		GetPrivateProfileInt(INI_KEY_AUTO_CR,
								FALSE,					//	Auto CR
								(LPCSTR) strIniFile);
	m_bAnsiMode =
		GetPrivateProfileInt(INI_KEY_ANSI_MODE,
								FALSE,					//	h-19 escapes mode
								(LPCSTR) strIniFile);
	m_bShiftedMode = 
		GetPrivateProfileInt(INI_KEY_KEYPAD_SHIFTED,
								FALSE,					//	keypad unshifted
								(LPCSTR) strIniFile);
	m_bInhibitCursor = TRUE;
	m_bICSent = FALSE;
	m_bInverseVideoMode = FALSE;	//	video not inverted
	m_bGraphicsMode = FALSE;		//	text	
	m_bAlternateMode = FALSE;		//	keypad not alternate
	m_bHoldScreenMode = FALSE;		//	scrolling enabled
	m_bInsertCharMode = FALSE;		//	non-insert mode
	m_bShowCursor = TRUE;			//	cursor is visible
	m_bAutoLF = FALSE;				//	no auto-LF
	m_b25thLineMode = TRUE;			//	25th line on so we can clear it.
	SetCursorPosition(25, 1);
	ClearLine(bRedraw);
	m_b25thLineMode = FALSE;		//	25th line off
	HomeCursor();
	ClearToEndOfScreen(bRedraw);
	m_bInhibitCursor = FALSE;
}


//	HomeCursor: set the cursor position to 1,1

void	ScreenWindow :: HomeCursor()
{
	SetCursorPosition(1, 1);
}


//	SetCursorPosition: set the cursor to specified line and column

void	ScreenWindow :: SetCursorPosition(int nLine, int nColumn)
{
	m_nCursorLine = nLine;
	m_nCursorColumn = nColumn;
}


//	SaveCursorPosition: make a copy of the current cursor position

void	ScreenWindow :: SaveCursorPosition()
{
	m_nSavedCursorLine = m_nCursorLine;
	m_nSavedCursorColumn = m_nCursorColumn;
}


//	RestoreCursorPosition: set the cursor position to saved values.

void	ScreenWindow :: RestoreCursorPosition()
{
	m_nCursorLine = m_nSavedCursorLine;
	m_nCursorColumn = m_nSavedCursorColumn;
}


//	CursorRight: Advance the cursor a column unless already at right edge

void	ScreenWindow :: CursorRight()
{
	if (m_nCursorColumn < 80) ++m_nCursorColumn;
}


//	CursorLeft: Back up the cursor a column unless already at left edge

void	ScreenWindow :: CursorLeft()
{
	if (m_nCursorColumn > 1) --m_nCursorColumn;
}


//	CursorDown: Advance the cursor a line unless already at line 24

void	ScreenWindow :: CursorDown()
{
	if (m_nCursorLine < 24) ++m_nCursorLine;
}


//	Move all the lines from 2 through m_nCursorLine up one.
//	Fill m_nCursorLine with spaces.

void	ScreenWindow :: ScrollUp()
{
	int	nCount;
	int	nAttribute;

	nAttribute = ((m_bInverseVideoMode ? ATTRIB_INVERSE : 0) +
				 (m_bGraphicsMode ? ATTRIB_GRAPHIC : 0) +
				 ((m_nFG & 7) << 2) +
				 ((m_nBG & 7) << 5));

	nCount = 2 * 80 * (m_nCursorLine - 1);
	memmove(&m_cRaster[0][0][0], &m_cRaster[1][0][0], nCount);
	for (nCount = 1; nCount < 81; ++nCount)
	{
		m_cRaster[m_nCursorLine - 1][nCount - 1][0] = ' ';
		m_cRaster[m_nCursorLine - 1][nCount - 1][1] = (char) nAttribute;
	}
	MoveScreen(2, 24, -1);
	RepaintLine(24);
}


//	Insert line: reverse scroll from current line, then set cursor to column 1.

void	ScreenWindow :: InsertLine()
{
	int	nI;
	int	nCount;
	int	nAttribute;

	nAttribute = ((m_bInverseVideoMode ? ATTRIB_INVERSE : 0) +
				 (m_bGraphicsMode ? ATTRIB_GRAPHIC : 0) +
				 ((m_nFG & 7) << 2) +
				 ((m_nBG & 7) << 5));
	nCount = 2 * 80 * (24 - m_nCursorLine);
	memmove(&m_cRaster[m_nCursorLine][0][0],
			&m_cRaster[m_nCursorLine - 1][0][0],
			nCount);
	for (nI = 0; nI < 80; ++nI)
	{
		m_cRaster[m_nCursorLine - 1][nI][0] = ' ';
		m_cRaster[m_nCursorLine - 1][nI][1] =
			(char) nAttribute;
	}
	m_nCursorColumn = 1;
	MoveScreen(m_nCursorLine, 23, 1);
	RepaintLine(m_nCursorLine);
}


//	Delete line:  Copy the next line through end of screen onto current line;
//	set line 24 to all blanks.

void	ScreenWindow :: DeleteLine()
{
	int nI;
	int nCount;
	int nAttribute;

	nAttribute = ((m_bInverseVideoMode ? ATTRIB_INVERSE : 0) +
				 (m_bGraphicsMode ? ATTRIB_GRAPHIC : 0) +
				 ((m_nFG & 7) << 2) +
				 ((m_nBG & 7) << 5));
	nCount = 2 * 80 * (24 - m_nCursorLine);
	memmove(&m_cRaster[m_nCursorLine - 1][0][0],
			&m_cRaster[m_nCursorLine][0][0],
			nCount);
	for (nI = 0; nI < 80; ++nI)
	{
		m_cRaster[23][nI][0] = ' ';
		m_cRaster[23][nI][1] =
			(char) nAttribute;
	}
	m_nCursorColumn = 1;
	MoveScreen(m_nCursorLine + 1, 24, -1);
	RepaintLine(24);
}


//	Delete character:  Copy the next character through end of line onto current
//	character; set character 80 to a blank.

void	ScreenWindow :: DeleteCharacter()
{
	int nCount;
	int nAttribute;

	nAttribute = ((m_bInverseVideoMode ? ATTRIB_INVERSE : 0) +
				 (m_bGraphicsMode ? ATTRIB_GRAPHIC : 0) +
				 ((m_nFG & 7) << 2) +
				 ((m_nBG & 7) << 5));
	nCount = 2 * (80 - m_nCursorColumn);
	memmove(&m_cRaster[m_nCursorLine - 1][m_nCursorColumn - 1][0],
			&m_cRaster[m_nCursorLine - 1][m_nCursorColumn][0],
			nCount);
	m_cRaster[m_nCursorLine - 1][79][0] = ' ';
	m_cRaster[m_nCursorLine - 1][79][1] = (char) nAttribute;
	RepaintLine(m_nCursorLine);
}


//	CursorUp: Back up the cursor a line unless already at line 1

void	ScreenWindow :: CursorUp()
{
	if (m_nCursorLine > 1) --m_nCursorLine;
}


//	ClearToEndOfScreen: erase the display from cursor position to 25,80.
//	TODO:	Check this -- line 25 might be protected, in which case change
//	the for loop limits to position 24,80 instead.

void	ScreenWindow :: ClearToEndOfScreen(BOOL bRedraw)
{
	int	nI;
	int nJ;
	
	for (nI = m_nCursorLine - 1; nI < 24; ++nI)
	{
		for (nJ = m_nCursorColumn - 1; nJ < 80; ++nJ)
		{
			m_cRaster[nI][nJ][0] = ' ';
			m_cRaster[nI][nJ][1] =

#ifndef STRICT_EMULATION

			(char) (((m_nBG << 5) & 0x0ff) + ((m_nFG << 2) & 0x0ff));

#else

			(char) 0;
#endif

		}
	}
	if (bRedraw) RepaintScreen();
}


//	ClearToStartOfScreen: erase the display from cursor position to 0,0.
//	TODO:	Check this -- line 25 might be different, in which case change
//	the for loop limits to position 25,00 instead.

void	ScreenWindow :: ClearToStartOfScreen()
{
	int	nI;
	int nJ;
	
	for (nI = 0; nI < m_nCursorLine - 1; ++nI)
	{
		for (nJ = 0; nJ < 80; ++nJ)
		{
			m_cRaster[nI][nJ][0] = ' ';
			m_cRaster[nI][nJ][1] =

#ifndef STRICT_EMULATION

			(char) (((m_nBG << 5) & 0x0ff) + ((m_nFG << 2) & 0x0ff));

#else

			(char) 0;
#endif

		}
	}

//	Note: unsure whether or not we erase the character at the cursor, too.

	for (nJ = 0; nJ < m_nCursorColumn - 1; ++nJ)
	{
		m_cRaster[nI][nJ][0] = ' ';
		m_cRaster[nI][nJ][1] =

#ifndef STRICT_EMULATION

			(char) (((m_nBG << 5) & 0x0ff) + ((m_nFG << 2) & 0x0ff));

#else

			(char) 0;
#endif

	}
	RepaintScreen();
}


//	ClearToEndOfLine: erase from cursor position to column 80 in current line.

void	ScreenWindow :: ClearToEndOfLine()
{
	int nJ;

	for (nJ = m_nCursorColumn - 1; nJ < 80; ++nJ)
	{
		m_cRaster[m_nCursorLine - 1][nJ][0] = ' ';
		m_cRaster[m_nCursorLine - 1][nJ][1] =

#ifndef STRICT_EMULATION

			(char) (((m_nBG << 5) & 0x0ff) + ((m_nFG << 2) & 0x0ff));

#else

			(char) 0;
#endif

	}
	RepaintLine(m_nCursorLine);
}


//	ClearToStartOfLine: erase from column 1 to cursor position in current line.
//	This operation must erase the character under the cursor as well.

void	ScreenWindow :: ClearToStartOfLine()
{
	int nJ;

	for (nJ = 0; nJ < m_nCursorColumn; ++nJ)
	{
		m_cRaster[m_nCursorLine - 1][nJ][0] = ' ';
		m_cRaster[m_nCursorLine - 1][nJ][1] =

#ifndef STRICT_EMULATION

			(char) (((m_nBG << 5) & 0x0ff) + ((m_nFG << 2) & 0x0ff));

#else

			(char) 0;
#endif

	}
	RepaintLine(m_nCursorLine);
}


//	ClearLine: erase current line.  Cursor is not repositioned.

void	ScreenWindow :: ClearLine(BOOL bRedraw)
{
	int nJ;

	for (nJ = 0; nJ < 80; ++nJ)
	{
		m_cRaster[m_nCursorLine - 1][nJ][0] = ' ';
		m_cRaster[m_nCursorLine - 1][nJ][1] =

#ifndef STRICT_EMULATION

			(char) (((m_nBG << 5) & 0x0ff) + ((m_nFG << 2) & 0x0ff));

#else

			(char) 0;
#endif

	}
	if (bRedraw) RepaintLine(m_nCursorLine);
}


//	WriteToDisplay: append the current character at the cursor position
//	using the current video modes.  Then advance the cursor.

void	ScreenWindow :: WriteToDisplay(char cData)
{
	int	nAttribute;
	int	nCount;

	nAttribute = ((m_bInverseVideoMode ? ATTRIB_INVERSE : 0) |
				 (m_bGraphicsMode ? ATTRIB_GRAPHIC : 0) |
				 ((m_nFG & 7) << 2) |
				 ((m_nBG & 7) << 5));
	if (m_bInsertCharMode)
	{

//	Move all characters from cursor position to end of current line one column
//	to the right, discarding at end of line.

		nCount = 80 - m_nCursorColumn;
		memmove(&(m_cRaster[m_nCursorLine - 1][m_nCursorColumn][0]),
				&(m_cRaster[m_nCursorLine - 1][m_nCursorColumn - 1][0]),
				nCount * 2);
		RepaintLine(m_nCursorLine);
	}
	m_cRaster[m_nCursorLine - 1][m_nCursorColumn - 1][0] = cData;
	m_cRaster[m_nCursorLine - 1][m_nCursorColumn - 1][1] = (char) nAttribute;
	RedrawCursor();
	if (m_nCursorColumn < 80)
	{
		m_nCursorColumn++;
	}
	else
	{
		if (m_bWrapMode)
		{
			m_nCursorColumn = 1;
			if ((m_nCursorLine == 25) ||
				(m_bHoldScreenMode && (m_nCursorLine == 24)))
			{
			}
			else if (m_nCursorLine == 24)
			{
				ScrollUp();
			}
			else
			{
				m_nCursorLine++;
			}
		}
	}
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


//	Keystroke -- handle the keystroke from the simulated keyboard, having now
//	determined exactly what key and combination of shift states created it. If
//	the code is between 0 and 128, it's an actual ascii character.  Otherwise,
//	the keystroke is a function key or was from the keypad.  These keys will be
//	codes between 128 and 256, depending on shift state(s) -- use the defined
//	constants for SHIFT_F1, KEYPAD_UPARROW, etc. when determining what
//	characters should be sent to the UART.

void	ScreenWindow :: Keystroke(int nCode)
{

//	For now, nCode must be an 8-bit value.

	nCode = nCode & 0x00FF;
	if (nCode < 128)	//	nCode is between 0 and 127.
	{

//	Control character or ordinary ascii character call CharacterOut once with
//	bInterlock FALSE.

//	Possible exception: CR and LF may be affected by the AutoCR mode.

		CharacterOut((char) nCode);
	}
	else	//	nCode between 128 and 256.
	{
	
//	Special function key.  Convert to escape sequence then call CharacterOut
//	with bInterlock TRUE except for the last character in the sequence.
//
//	Note: For some keys, what gets sent depends on m_Screen mode bits, so we
//	must look at them in order to send the correct sequence, based on the
//	InsertCharacter, Alternate, KeypadShifted and ANSI mode bit values.

//	Function keys are coded from 128 through 167 with no gaps.

//	Keypad keys are coded in blocks of 12:
//	
//	168 - 179 (no modifiers),
//	188 - 199 (control),
//	208 - 219 (shift)
//	228 - 239 (control-shift).

//	Scroll lock is code 240.

//	Break is code 241.

//	Remaining codes are not assigned.

//	Note: even though these keys may be sending unique codes when control and/or
//	shift is pressed in combination, the escape sequence the key generates may
//	not depend on the shift/control state.  If it does not, we simply funnel any
//	redundant cases into the same execution.

//	Note: Keypad ENTER may be affected by the AutoCR mode.

		switch(nCode)
		{
		case 128:	//	f1
		case 138:	//	control-f1
		case 148:	//	shift-f1
		case 158:	//	shift-control-f1
			if (!m_bAnsiMode)
			{
				CharacterOut(ESC, TRUE);
				CharacterOut('S');
			}
			else
			{
			}
			break;
		case 129:	//	f2
		case 139:	//	control-f2
		case 149:	//	shift-f2
		case 159:	//	shift-control-f2
			if (!m_bAnsiMode)
			{
				CharacterOut(ESC, TRUE);
				CharacterOut('T');
			}
			else
			{
			}
			break;
		case 130:	//	f3
		case 140:	//	control-f3
		case 150:	//	shift-f3
		case 160:	//	shift-control-f3
			if (!m_bAnsiMode)
			{
				CharacterOut(ESC, TRUE);
				CharacterOut('U');
			}
			else
			{
			}
			break;
		case 131:	//	f4
		case 141:	//	control-f4
		case 151:	//	shift-f4
		case 161:	//	shift-control-f4
			if (!m_bAnsiMode)
			{
				CharacterOut(ESC, TRUE);
				CharacterOut('V');
			}
			else
			{
			}
			break;
		case 132:	//	f5
		case 142:	//	control-f5
		case 152:	//	shift-f5
		case 162:	//	shift-control-f5
			if (!m_bAnsiMode)
			{
				CharacterOut(ESC, TRUE);
				CharacterOut('W');
			}
			else
			{
			}
			break;
		case 133:	//	erase
		case 143:	//	control-erase
			if (!m_bAnsiMode)
			{
				CharacterOut(ESC, TRUE);
				CharacterOut('J');
			}
			else
			{
			}
			break;
		case 134:	//	blue
		case 144:	//	control-blue
		case 154:	//	shift-blue
		case 164:	//	shift-control-blue
			if (!m_bAnsiMode)
			{
				CharacterOut(ESC, TRUE);
				CharacterOut('P');
			}
			else
			{
			}
			break;
		case 135:	//	red
		case 145:	//	control-red
		case 155:	//	shift-red
		case 165:	//	shift-control-red
			if (!m_bAnsiMode)
			{
				CharacterOut(ESC, TRUE);
				CharacterOut('Q');
			}
			else
			{
			}
			break;
		case 136:	//	gray
		case 146:	//	control-gray
		case 156:	//	shift-gray
		case 166:	//	shift-control-gray
			if (!m_bAnsiMode)
			{
				CharacterOut(ESC, TRUE);
				CharacterOut('R');
			}
			else
			{
			}
			break;
		case 137:	//	reset
		case 147:	//	control-reset
			if (!m_bAnsiMode)
			{
			}
			else
			{
			}
			break;
		case 153:	//	shift-erase
		case 163:	//	shift-control-erase
			if (!m_bAnsiMode)
			{
				CharacterOut(ESC, TRUE);
				CharacterOut('E');
			}
			else
			{
			}
			break;
		case 157:	//	shift-reset
		case 167:	//	shift-control-reset
			if (!m_bAnsiMode)
			{
			}
			else
			{
			}
			break;
		case 168:	//	kp7
		case 188:	//	ctl-kp7
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('7');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('w');
					}
				}
				else
				{

//	IC / IC-NOT
					if (m_bICSent)
					{
						m_bICSent = FALSE;
						CharacterOut(ESC, TRUE);
						CharacterOut('O');
					}
					else
					{
						m_bICSent = TRUE;
						CharacterOut(ESC, TRUE);
						CharacterOut('@');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 169:	//	kp8
		case 189:	//	ctl-kp8
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('8');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('x');
					}
				}
				else
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('A');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 170:	//	kp9
		case 190:	//	ctl-kp9
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('9');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('y');
					}
				}
				else
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('N');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 171:	//	kp4
		case 191:	//	ctl-kp4
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('4');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('t');
					}
				}
				else
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('D');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 172:	//	kp5
		case 192:	//	ctl-kp5
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('5');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('u');
					}
				}
				else
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('H');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 173:	//	kp6
		case 193:	//	ctl-kp6
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('6');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('v');
					}
				}
				else
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('C');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 174:	//	kp1
		case 194:	//	ctl-kp1
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('1');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('q');
					}
				}
				else
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('L');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 175:	//	kp2
		case 195:	//	ctl-kp2
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('2');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('r');
					}
				}
				else
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('B');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 176:	//	kp3
		case 196:	//	ctl-kp3
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('3');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('s');
					}
				}
				else
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('M');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 177:	//	kp0
		case 197:	//	ctl-kp0
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('0');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('p');
					}
				}
				else
				{
					CharacterOut('0');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 178:	//	kpdot
		case 198:	//	ctl-kpdot
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('.');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('n');
					}
				}
				else
				{
					CharacterOut('.');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('.');
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 179:	//	kpenter
		case 199:	//	ctl-kpenter
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('\r');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('M');
					}
				}
				else
				{
					CharacterOut('\r');
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 208:	//	shift-kp7
		case 228:	//	ctl-shift-kp7
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{

//	IC / IC-NOT

					if (m_bICSent)
					{
						m_bICSent = FALSE;
						CharacterOut(ESC, TRUE);
						CharacterOut('O');
					}
					else
					{
						m_bICSent = TRUE;
						CharacterOut(ESC, TRUE);
						CharacterOut('@');
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('7');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('w');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 209:	//	shift-kp8
		case 229:	//	ctl-shift-kp8
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('A');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('8');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('x');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 210:	//	shift-kp9
		case 230:	//	ctl-shift-kp9
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('N');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('9');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('y');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 211:	//	shift-kp4
		case 231:	//	ctl-shift-kp4
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('D');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('4');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('t');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 212:	//	shift-kp5
		case 232:	//	ctl-shift-kp5
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('H');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('5');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('u');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 213:	//	shift-kp6
		case 233:	//	ctl-shift-kp6
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('C');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('6');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('v');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 214:	//	shift-kp1
		case 234:	//	ctl-shift-kp1
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('L');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('1');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('q');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 215:	//	shift-kp2
		case 235:	//	ctl-shift-kp2
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('B');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('2');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('r');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 216:	//	shift-kp3
		case 236:	//	ctl-shift-kp3
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut(ESC, TRUE);
					CharacterOut('M');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('3');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('s');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 217:	//	shift-kp0
		case 237:	//	ctl-shift-kp0
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut('0');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('0');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('p');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 218:	//	shift-kpdot
		case 238:	//	ctl-shift-kpdot
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut('.');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('.');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('n');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 219:	//	shift-kpenter
		case 239:	//	ctl-shift-kpenter
			if (!m_bAnsiMode)
			{
				if (!m_bShiftedMode)
				{
					CharacterOut('\r');
				}
				else
				{
					if (!m_bAlternateMode)
					{
						CharacterOut('\r');
					}
					else
					{
						CharacterOut(ESC, TRUE);
						CharacterOut('?', TRUE);
						CharacterOut('M');
					}
				}
			}
			else
			{
				if (!m_bShiftedMode)
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
				else
				{
					if (!m_bAlternateMode)
					{
					}
					else
					{
					}
				}
			}
			break;
		case 240:	//	scroll lock
			break;
		case 241:	//	break
			SendBreak();
			break;
		default:

//	Unassigned code.  Should never get here. Ignore keystroke.

			break;
		}
	}
}


//	CharacterOut -- convert keystroke(s) to an EmitMessage call.

void	ScreenWindow :: CharacterOut(char cData, BOOL bInterlock)
{
	if (!m_bLocal)
	{
		SendOut(cData, bInterlock);
	}
	else
	{
		CharacterIn(cData);
	}
}

//	TransmitLine -- sends a whole line as one message

void	ScreenWindow :: TransmitLine(int nLine)
{
	int nI;

	if ((nLine < 25) || (m_b25thLineMode))
	{
		TransmitCharacter(nLine, 1, TRUE, FALSE);
		for (nI = 2; nI < 80; ++nI) TransmitCharacter(nLine, nI, TRUE, TRUE);
		TransmitCharacter(nLine, 80, FALSE, TRUE);
	}
}

//	Transmit Page -- sends a whole page as one message

void	ScreenWindow :: TransmitPage()
{
	int nI;
	int	nJ;
	int	nLastLine = m_b25thLineMode ? 25 : 24;

//	TODO:	Does "Transmit Page ever transmit line 25, as coded?

	TransmitCharacter(1, 1, TRUE, FALSE);
	for (nJ = 2; nJ < 81; ++nJ) TransmitCharacter(1, nJ, TRUE, TRUE);
	for (nI = 2; nI < nLastLine; ++nI)
	{
		for (nJ = 1; nJ < 81; ++nJ) TransmitCharacter(nI, nJ, TRUE, TRUE);
	}
	for (nJ = 1; nJ < 80; ++nJ) TransmitCharacter(nLastLine, nJ, TRUE, TRUE);
	TransmitCharacter(nLastLine, 80, FALSE, TRUE);
}

//	Synthesize the necessary character sequence to implement a "send the
//	complete description of the character at nLine,nColumn".  If bInterlock is
//	true, we send the sequence with bInterlock set on every character; otherwise
//	we send the sequence with bInterlock asserted on all but the last character.
//	Note: will do nothing in Local mode.

void	ScreenWindow :: TransmitCharacter(int nLine,
											int nColumn,
											BOOL bInterlock, BOOL bUseHistory)
{
	char		cBuffer[32];	//	bigger than needed: we send 9 bytes in Heath mode, enhanced emulation.
	int			nAttribute;
	int			nI = 0;
	char		cData;
	static int	nPriorAttribute;

	if (!m_bLocal)
	{
		nAttribute = m_cRaster[nLine - 1][nColumn - 1][1];
		cData = m_cRaster[nLine - 1][nColumn - 1][0];

//	Examine the attribute bit-wise and generate the escape sequences necessary
//	to set or clear all attributes.

		if (!m_bAnsiMode)
		{
			if (m_bEnhancedEmulation)
			{
				if ((!bUseHistory) ||
					((nPriorAttribute & 0xFC) != (nAttribute & 0xFC)))
				{

//	Color change.

					cBuffer[nI++] = ESC;
					cBuffer[nI++] = 'm';
					cBuffer[nI++] = '0' + ((nAttribute & 0xE0) >> 5);
					cBuffer[nI++] = '0' + ((nAttribute & 0x1C) >> 3);
				}
			}
			if ((!bUseHistory) ||
				((nPriorAttribute & ATTRIB_INVERSE) !=
					(nAttribute & ATTRIB_INVERSE)))
			{

//	Video inversion change

				cBuffer[nI++] = ESC;
				cBuffer[nI++] = ((nAttribute & ATTRIB_INVERSE) ? 'p' : 'q');
			}
			if ((!bUseHistory) ||
				((nPriorAttribute & ATTRIB_GRAPHIC) !=
					(nAttribute & ATTRIB_GRAPHIC)))
			{

//	Graphic attribute change

				cBuffer[nI++] = ESC;
				cBuffer[nI++] = ((nAttribute & ATTRIB_GRAPHIC) ? 'F' : 'G');
			}
			cBuffer[nI++] = cData;
			cBuffer[nI] = 0;
		}
		else
		{

//	TODO:	ANSI mode not implemented.

		}
		for (nI = 0; cBuffer[nI + 1] != 0; ++nI)
		{
			SendOut(cBuffer[nI], TRUE);
		}
		SendOut(cBuffer[nI], bInterlock);
		if (bInterlock)
		{

//	If bInterlock is set, save our attribute in nPriorAttribute; there's
//	probably another TransmitCharacter to come.

			nPriorAttribute = nAttribute;
		}
	}
}


void	ScreenWindow :: SendOut(char cData, BOOL bInterlock)
{
	static char	cBuffer[18000];		//	Big enough for the worst-case send page -- where every other character is a graphic in a different color!
	static int	nBufferLength = 0;
	CString		strMessageText;
	int			nI;
	int			nJ;

//	This does output character work for both on-line sending of keystrokes and
//	for sending of "response" sequences like ReportCursorPosition or SendPage.
//
//	Unlike the actual H19, we "batch" multi-character messages into a single
//	transmission on the pipe interface.  Partially, we do this for efficiency's
//	sake -- there's less overhead that way; partially we do this because it is
//	the only way to distinguish between an escape sequence sent by a function
//	key and the escape key followed by another character.  Normally, the time
//	delay between characters, as seen by the code running on the H8 would be how
//	the software can tell the difference, but we aren't simulating "baud rate
//	delays" in the read-from-UART emulation, so we use an "interlock" flag to
//	indicate when messages are made of multiple characters and the H8 code uses
//	end of message to institute a "typing rate" delay before allowing another
//	character to be read.
//
//	When bInterlock is not set, the code will output a single-character message.
//	While bInterlock is set, it will instead save up all characters given and
//	output as a "burst" when a character with bInterlock not set is given.
//	(bInterlock will normally only be set when a "function key" is pressed or
//	when shifting in and out of graphics mode while transmitting a character or
//	when sending a data block due to a send line or send page.)
//
//	There is logic to ensure that the worst-case cBuffer contents can still be
//	transmitted -- we presume the worst-case is when cBuffer contains nothing
//	but control characters.  Control characters take four bytes to encode and
//	the message formatting syntax adds another, plus two surrounding bytes, plus
//	four bytes for the command code, plus two bytes of whitespace.  This means
//	that the worst-case encoding could still send about 196 characters in one
//	1024-character message.

//	We define the message block size limit at 180 characters just to be safe.
//	This means that we could be sending as many as 100 messages in a worst-case
//	operation (a transmit page of 2000 characters -- each of which encodes as
//	three escape characters and six printable characters).

#define	BLOCK_LENGTH	180


//	The whole thing is moot in local mode -- we do nothing at all.  (We would
//	not be called due to a keystroke but we might be called due to a response
//	such as "transmit page".)

	if (bInterlock)
	{

//	Save this character in the buffer but do not send it yet.

		cBuffer[nBufferLength++] = cData;
	}
	else
	{
		if (nBufferLength == 0)
		{

//	Send this character as a single message.

			strMessageText = cData;
			theApp.m_Bus.H19MessageIn(strMessageText);
		}
		else if (nBufferLength < BLOCK_LENGTH)
		{

//	Append this character to the buffer.

			cBuffer[nBufferLength++] = cData;

//	The total byte count is low enough so that we can format the entire text as
//	a single message, Therefore, use the entire buffer to make a "burst mode"
//	message.

			cBuffer[nBufferLength] = 0;
			strMessageText = cBuffer;
			theApp.m_Bus.H19MessageIn(strMessageText);

//	Reset the buffer length to zero.

			nBufferLength = 0;
		}
		else
		{

//	Append this character to the buffer.

			cBuffer[nBufferLength++] = cData;

//	Will have to do this text as multiple messages.  Must also be sure not to
//	split an escape sequence between two messages.

			nI = 0;
			do
			{
				strMessageText = "";
				for (nJ = 0; nJ < BLOCK_LENGTH; ++nJ)
				{

//	Stop if we run out of data.

					if ((nJ + nI) >= nBufferLength) break;
					strMessageText += cBuffer[nI + nJ];
				}
				nI = nI + nJ;
				theApp.m_Bus.H19MessageIn(strMessageText);
			} while (nI < nBufferLength);

//	Reset the buffer length to zero.

			nBufferLength = 0;
		}
	}
}



//	The break sends a special message and does nothing in local mode.

void	ScreenWindow :: SendBreak()
{
	if (!m_bLocal)
	{
		theApp.m_Bus.H19Break();
	}
}


//	ReceiveBreak -- the H19 got a BREAK as input.

void	ScreenWindow :: ReceiveBreak()
{

//	TODO: How does the H19 respond to BREAK?

}


//	CharacterIn -- handles characters one at a time as recieved H-8

void	ScreenWindow :: CharacterIn(char cData)
{
	static TTY_STATE eState = BASE;
	static			cCommand;
	static			cParam1;

	cData &= 0x07f;	//	Strip high bit always.

//	It's simpler to have a separate state machine for Ansi mode and for H19
//	native mode.

	m_bInhibitCursor = TRUE;
	RedrawCursor();
	if (!m_bAnsiMode)
	{

//	If we're in an escape sequence, parse then execute; else store the
//	character in the raster array, with graphics and inverse as currently set.

		switch(eState)
		{
		case BASE:
			switch(cData)
			{
			case BEL:
				Beep(1000,100);		//	probably enough said.
				break;
			case BS:

//	Cursor movement is required for BS.

				if (m_nCursorColumn != 1)
				{
					m_nCursorColumn--;
				}
				break;
			case HT:

//	Cursor movement is required for the HT.

				m_nCursorColumn =
					((m_nCursorColumn -1) / 8) + 1;
				m_nCursorColumn *= 8;
				++m_nCursorColumn;
				if (m_nCursorColumn > 80)
					m_nCursorColumn = 80;
				break;
			case LF:

//	Cursor movement is required for the LF.  If we are in AutoCR mode, we also
//	send the cursor to column 1.

				if (m_nCursorLine < 24) CursorDown();
				else
				{
					CursorDown();
					ScrollUp();
				}
				if (m_bAutoCR)
				{
					m_nCursorColumn = 1;
				}
				break;
			case CR:

//	Cursor movement is required for the carriage return.  If AutoLF mode is set,
//	we also do a linefeed.

				m_nCursorColumn = 1;
				if (m_bAutoLF)
				{
					if (m_nCursorLine < 24) CursorDown();
					else
					{
						CursorDown();
						ScrollUp();
					}
				}
				break;
			case XON:
			case XOFF:

//	not sure how these characters act.

				break;
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case VT:
			case FF:
			case 14:
			case 15:
			case 16:
			case 18:
			case 20:
			case 21:
			case 22:
			case 23:
			case CAN:
			case 25:
			case 26:
			case 28:
			case 29:
			case 30:
			case 31:
			case DEL:

//	Unprocessed control characters -- ignore them.

				break;
			case ESC:
				eState = ESCAPE;
				break;
			default:

//	Not a special character, just write it to the display.

				WriteToDisplay(cData);
				break;
			}
			break;
		case ESCAPE:
			switch(cData)
			{
			case ESC:
				eState = ESCAPE;
				break;
			case '@':
				m_bInsertCharMode = TRUE;
				m_bICSent = TRUE;
				eState = BASE;
				break;
			case '=':
				m_bAlternateMode = TRUE;
				eState = BASE;
				break;
			case '>':
				m_bAlternateMode = FALSE;
				eState = BASE;
				break;
			case '<':
//				m_bAnsiMode = TRUE;
				eState = BASE;
				break;
			case '#':
				TransmitPage();
				break;
			case 'A':
				CursorUp();
				eState = BASE;
				break;
			case 'B':
				CursorDown();
				eState = BASE;
				break;
			case 'C':
				CursorRight();
				eState = BASE;
				break;
			case 'D':
				CursorLeft();
				eState = BASE;
				break;
			case 'E':
				HomeCursor();
				ClearToEndOfScreen();
				eState = BASE;
				break;
			case 'F':
				m_bGraphicsMode = TRUE;
				eState = BASE;
				break;
			case 'G':
				m_bGraphicsMode = FALSE;
				eState = BASE;
				break;
			case 'H':
				HomeCursor();
				eState = BASE;
				break;
			case 'I':
				if (m_nCursorLine > 1)
				{
					CursorUp();
				}
				else
				{
					InsertLine();
				}
				eState = BASE;
				break;
			case 'J':
				ClearToEndOfScreen();
				eState = BASE;
				break;
			case 'K':
				ClearToEndOfLine();
				eState = BASE;
				break;
			case 'L':
				InsertLine();
				eState = BASE;
				break;
			case 'M':
				DeleteLine();
				break;
			case 'N':
				DeleteCharacter();
				break;
			case 'O':
				m_bInsertCharMode = FALSE;
				m_bICSent = FALSE;
				eState = BASE;
				break;
			case 'Y':
				cCommand = 'Y';
				eState = ARG1;
				break;
			case 'Z':
				CharacterOut(ESC, TRUE);
				CharacterOut('/', TRUE);
				CharacterOut('K');
				break;
			case '[':	//	Enter Hold Screen mode
			case '\\':	//	Exit Hold Screen mode
			case ']':
				TransmitLine(25);
				break;
			case 'b':
				ClearToStartOfScreen();
				eState = BASE;
				break;
			case 'j':
				m_nSavedCursorColumn = m_nCursorColumn;
				m_nSavedCursorLine = m_nCursorLine;
				eState = BASE;
				break;
			case 'k':
				m_nCursorColumn = m_nSavedCursorColumn;
				m_nCursorLine = m_nSavedCursorLine;
				eState = BASE;
				break;
			case 'l':
				ClearLine();
				eState = BASE;
				break;
			case 'm':

#ifndef STRICT_EMULATION

				cCommand = 'm';
				eState = ARG1;

#else
				if (isprint(cData)) WriteToDisplay(cData);
				eState = BASE;

#endif

				break;
			case 'n':
				CharacterOut(ESC, TRUE);
				CharacterOut((char)(' ' + m_nCursorLine - 1), TRUE);
				CharacterOut((char)(' ' + m_nCursorColumn - 1));
				break;
			case 'o':
				ClearToStartOfLine();
				eState = BASE;
				break;
			case 'p':
				m_bInverseVideoMode = TRUE;
				eState = BASE;
				break;
			case 'q':
				m_bInverseVideoMode = FALSE;
				eState = BASE;
				break;
			case 'r':	//	arg1=Bn	Modify baud rate - not supported
				eState = ARG1;
				cCommand = 'r';
				break;
			case 't':
				m_bShiftedMode = TRUE;
				eState = BASE;
				break;
			case 'u':
				m_bShiftedMode = FALSE;
				eState = BASE;
				break;
			case 'v':
				m_bWrapMode = TRUE;
				eState = BASE;
				break;
			case 'w':
				m_bWrapMode = FALSE;
				eState = BASE;
				break;
			case 'x':	//	arg1=Ps Set Mode. See table below
				cCommand = 'x';
				eState = ARG1;
				break;
			case 'y':	//	arg1=Ps	Reset Mode. See table below
				cCommand = 'y';
				eState = ARG1;
				break;
			case 'z':	//	Reset to power-up configuration
				SetPowerupConfiguration(TRUE);
				eState = BASE;
				break;
			case '{':	//	Enable Keyboard -- not supported
			case '}':	//	Disable Keyboard -- not supported
				eState = BASE;
				break;

//	These escapes are ones we generate (example: ESC-S is the f1 key) which
//	cause no action when received but are recognized and silently ignored.

			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
				eState = BASE;
				break;

//	These escapes are similar to the above, but are three-character sequences.

			case '/':
			case '?':
				cCommand = cData;
				eState = ARG1;
				break;

//	The rest are probably not defined.  (Will check against real H19.)
//	In the case of an undefined escape sequence, echo the character (if it's
//	printable) and return to BASE state.

			default:

//	Unrecognized.  Output the character unescaped.  BE CAREFUL -- Don't output
//	inappropriate characters (like ESC).  THE CORRECT ANSWER IS RECURSION -- FIX!

				if (isprint(cData)) WriteToDisplay(cData);
				eState = BASE;
				break;
			}
			break;
		case ARG1:
			switch(cCommand)
			{
			case 'Y':

//	Cursor Positioning.  This argument is line number, with ' ' being line 1.

				if ((cData >= ' ') && (
										(m_b25thLineMode &&((cData - ' ') < 25)) ||
										((cData - ' ') < 24)))
				{
					cParam1 = cData;
					eState = ARG2;
				}
				else
				{
					WriteToDisplay((char) cCommand);
					if (isprint(cData)) WriteToDisplay((char) cData);
					eState = BASE;
				}
				break;
			case 'm':
				switch(cData)
				{
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
					cParam1 = cData;
					eState = ARG2;
					break;
				default:
					WriteToDisplay((char) cCommand);
					if (isprint(cData)) WriteToDisplay((char) cData);
					eState = BASE;
					break;
				}
				break;
			case 'x':	//	mode set
			case 'y':	//	mode reset

//	Both commands use the same ARG1 value to set or clear the same function.

				switch (cData)
				{
				case '1':
					if (cCommand != 'x')
					{

//	When line 25 is disabled, clear it.

						SetCursorPosition(25, 1);
						ClearLine();
						HomeCursor();
					}
					m_b25thLineMode = (cCommand == 'x');
					break;
				case '2':	//	key click -- not supported.
					break;
				case '3':	//  holdscreen
					m_bHoldScreenMode = (cCommand == 'x');
					break;
				case '4':
					m_bCursorIsBlock = (cCommand == 'x');
					break;
				case '5':
					m_bShowCursor = (cCommand == 'x');
					break;
				case '6':
					m_bShiftedMode = (cCommand == 'x');
					break;
				case '7':
					m_bAlternateMode = (cCommand == 'x');
					break;
				case '8':
					m_bAutoCR = (cCommand == 'x');
					break;
				case '9':
					m_bAutoLF = (cCommand == 'x');
					break;
				default:
					WriteToDisplay((char) cCommand);
					if (isprint(cData)) WriteToDisplay((char) cData);
					break;
				}
				eState = BASE;
				break;
			case 'K':
				if (cCommand != '/')
				{
					WriteToDisplay((char) cCommand);
					if (isprint(cData)) WriteToDisplay((char) cData);
				}
				eState = BASE;
				break;
			default:
				if (cCommand != '?')
				{
					WriteToDisplay((char) cCommand);
					if (isprint(cData)) WriteToDisplay((char) cData);
				}

//	We won't bother distinguish between ESC-?-<legal> and ESC-?-<illegal>; we
//	will simply ignore them all.

				eState = BASE;
				break;
			}
			break;
		case ARG2:
			switch(cCommand)
			{
			case 'Y':

//	Cursor positioning.  This argument is column number with ' ' being col. 1.

				if ((cData >= ' ') && ((cData - ' ') < 80))
				{
					SetCursorPosition(cParam1 - ' ' + 1, cData - ' ' + 1);
				}
				else
				{
					WriteToDisplay(cData);
				}
				eState = BASE;
				break;
			case 'm':
				switch(cData)
				{
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
					m_nBG = cData & 0x07;
					m_nFG = cParam1 &0x07;
					eState = BASE;
					break;
				default:
					WriteToDisplay(cData);
					eState = BASE;
					break;
				}
				break;
			case 'r':
				if ((cData >= 'A') && (cData <= 'L'))
				{

//	Baudrate setting is not supported.

				}
				else
				{
					WriteToDisplay(cData);
				}
				eState = BASE;
				break;
			default:
				WriteToDisplay(cData);
				eState = BASE;
				break;
			}
			break;
		default:
			break;
		}
	}
	else
	{
	}
	m_bInhibitCursor = FALSE;
	RedrawCursor();
	return; 
}
