/************************************************************************
 *																		*
 *	H8 EMULATOR Project --	MEMMAP.H									*
 *																		*
 *	Simulated address decoding and memory arrays of the Heathkit H-8	*
 *																		*
 *	------------------------------------------------------------------	*
 *																		*
 *	Copyright (c) 1998 - 2001 by	David A. Wallace					*
 *									154 Dunstable Rd.					*
 *									N. Chelmsford, MA					*
 *											01863-1202					*
 *																		*
 ************************************************************************/

#ifndef	_MEMMAP_H_
#define	_MEMMAP_H_

#ifndef _H8TYPES_H_
#include "h8types.h"
#endif


//	NOTE:  The H-17 controller has an additional memory (RAM) that has its
//	own write-protect feature.  When the H-17 is simulated, the memory map
//	object will need to be modified so that this additional RAM and its
//	protect logic is accounted for.

class	MemoryMap
{

//	Constructor / Destructor

public:

	MemoryMap();
	~MemoryMap();

//	Methods:

public:

	PBYTE			Read(PWORD nAddress);
	PWORD			Read2(PWORD nAddress);
	void			Write(PWORD nAddress, PBYTE nData);
	void			Write2(PWORD nAddress, PWORD nData);
	void			SetRomDisable(bool bSetting);
	int				GetDebugFlags(PWORD nAddress);
	void			SetDebugFlags(PWORD nAddress, PBYTE nData);
	void			LoadProm(PWORD nAddress, PBYTE nData);

protected:

private:
	__inline bool	IsRom(PWORD nAddress);

//	Attributes:

public:

protected:

private:

#ifndef _DEBUG

	PBYTE	m_szMemory[65536];
	PBYTE	m_szROMs[65536];

#else

	PBYTE	m_szMemory[65536][2];
	PBYTE	m_szROMs[65536][2];

#endif

	bool	m_bRomDisable;
};

#endif