/************************************************************************
 *																		*
 *	H8 EMULATOR Project --	virtual_h8.h								*
 *																		*
 *	Application object for the Heathkit H-8 simulator project			*
 *																		*
 *	------------------------------------------------------------------	*
 *																		*
 *	Copyright (c) 1998 - 2001 by	David A. Wallace					*
 *									154 Dunstable Rd.					*
 *									N. Chelmsford, MA					*
 *											01863-1202					*
 *																		*
 ************************************************************************/

// virtual_h8.h : main header file for the VIRTUAL_H8 application
//

#if !defined(AFX_VIRTUAL_H8_H__C9847058_7201_11D5_9C70_005004AF5E32__INCLUDED_)
#define AFX_VIRTUAL_H8_H__C9847058_7201_11D5_9C70_005004AF5E32__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif


#include "resource.h"		// main symbols


#ifndef _MSGS_H_
#include "msgs.h"
#endif



#ifndef _BUS_H_
#include "bus.h"
#endif

#ifndef _PAM_H_
#include "pam.h"
#endif

#ifndef _PROCESSOR_H_
#include "processor.h"
#endif

#ifndef _IPC_H_
#include "ipc.h"
#endif


typedef struct {
	HANDLE *			pEvent;
	unsigned long int	nExpirationTime;
} Schedule;


/////////////////////////////////////////////////////////////////////////////
// CVirtual_h8App:
// See virtual_h8.cpp for the implementation of this class
//

class CVirtual_h8App : public CWinApp
{
public:
	CVirtual_h8App();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVirtual_h8App)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CVirtual_h8App)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

//	Attributes:

public:
	Z80							m_Processor;
	unsigned long int			m_nProcessorCycles;
	IPC							m_IPC;
	Bus							m_Bus;
	Pam							m_PAM_IO_PORTS;
	struct XCON_IO				m_XCON_IO_PORTS;
	BOOL						m_bTimerTickEnable;
	FILE *						m_fpTapeIn;
	FILE *						m_fpTapeOut;
	CString						m_strH8Directory;
	CString						m_strTapeInPath;
	CString						m_strTapeOutPath;
	unsigned long int			m_nTimeSincePower;	//	msec since power-on
	CList <Schedule,
			Schedule>			m_clSchedules;		//	scheduler structs
	BOOL						m_bConnected[MAX_CONNECTIONS];
	CView *						m_pViewWnd;
	HGLOBAL						m_hSound;
	int							m_nTau;
protected:
private:

//	Methods:

public:
	BOOL		EmitMessage(int nConnectionId,
							int nCommandCode,
							CStringList & cslArgs);
	BOOL		EmitMessage(int nConnection, int nCommand, char * szArg = NULL);
	BOOL		IsConnected(int nConnection);
	BOOL		DisconnectPipes(int nConnectionId);
	void		DestroyPipes();
	BOOL		CreatePipes();
	BOOL		ScheduleWakeup(HANDLE * pWakeup, unsigned long int nDelay);

protected:
private:
	BOOL		ExistsDirectory(CString strDirectory);
	CString		Dequote(CString strPath);
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VIRTUAL_H8_H__C9847058_7201_11D5_9C70_005004AF5E32__INCLUDED_)
